play2x2 = xroom {
	var {
		firstenter=true;
		shuffled={};
		stack={{},{},{},{}};
		messages='';
		selected=false;
		win=false;
	},

	fading = function()
		return true, 2;
	end,

	enter=function(s)
		if s.firstenter or prefs.c2x2==0 then
			prefs.c2x2=prefs.c2x2+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;

	forcedsc=true;

	nam = [[Instead Solitaire]],
	disp = img('theme/insol.png'),
	dsc = function()
		return txtc([[Дважды два]]);
	end,
	xdsc = function(s)
		local x,y,t;
		t=[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
		if #s.shuffled==0 then
			if s.win==false then
				s.win=true;
			end;
			t=t..[[Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]];
			if s.win==true then
				prefs.cw2x2=prefs.cw2x2+1;
				prefs:store();
				s.win='saved';
			end;
		end;
		if #s.shuffled>0 then
			t=t..img('cards/backs/'..prefs.back..'.png')..img('cards/spacerhor.png');
		else
			t=t..img('cards/spacerhor.png');
		end;
		for x=1,4 do
			if #s.stack[x]>0 then
				if x==s.selected then
					t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/inactive/'..s.stack[x][#s.stack[x]][1]
					..s.stack[x][#s.stack[x]][2]..'.png')..'}'..img('cards/spacerhor.png');
				else
					t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/'..s.stack[x][#s.stack[x]][1]..
					s.stack[x][#s.stack[x]][2]..'.png')..'}'..img('cards/spacerhor.png');
				end;
			else
				t=t..img('cards/spacerhor.png')..img('cards/empty.png');
			end;
		end;
		t=t..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]
		t=t..[[^^{tryagain|Сыграть снова}^{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam='controller';
			act=function(s,w)
				w=tonumber(w);
				if play2x2.selected then
					if w~=play2x2.selected then
						if play2x2.stack[w][#play2x2.stack[w]][2]==play2x2.stack[play2x2.selected][#play2x2.stack[play2x2.selected]][2] then
							set_sound('sounds/card.wav');
							table.remove(play2x2.stack[w]);
							table.remove(play2x2.stack[play2x2.selected]);
							table.insert(play2x2.stack[w], table.remove(play2x2.shuffled));
							table.insert(play2x2.stack[play2x2.selected], table.remove(play2x2.shuffled));
						end;
					end;
					play2x2.selected=false;
				else
					set_sound('sounds/card.wav');
					play2x2.selected=w;
				end;
				return true;
			end;
		},
		xact('tryagain', code[[prefs.c2x2=prefs.c2x2+1;
		prefs:store(); play2x2.win=false; play2x2.selected=false; set_sound('sounds/click.wav');play2x2.shuffled=shuffle(play2x2.shuffled);
		local i;
		for i=1,4 do
			table.insert(play2x2.stack[i], table.remove(play2x2.shuffled));
		end;
		return true;]]);
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]);
	};
};

playbayan = xroom {
	var {
	shuffled={};
	selected=false;
	firstenter=true;
	win=false;
	
	};
	fading = function()
	return true, 2;
	end;
	enter=function(s)
		if s.firstenter or prefs.cbayan==0 then
			prefs.cbayan=prefs.cbayan+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;
	forcedsc=true;
	nam = [[Instead Solitaire]],
	dsc = function(s)
		return txtc([[Баян]]);
	end,
	xdsc = function(s)
		local x,y,t;
		t='';
		if #s.shuffled==1 then
			if not s.win then
				s.win=true;
			end;
			t=img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..[[
			Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
			if s.win==true then
				prefs.cwbayan=prefs.cwbayan+1;
				prefs:store();
				s.win='saved';
			end;
		end;
		if #s.shuffled>1 then
			for x=0,5 do
				for y=1,10 do
					if s.shuffled[x*10+y] then
						if x*10+y==s.selected then
							if y==10 then
								t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/inactive/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}';
							else
								t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/inactive/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}'..img('cards/spacerhor.png');
							end;
						else
							if y==10 then
								t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}';
							else
								t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}'..img('cards/spacerhor.png');
							end;
						end;
					else
						if y==10 then
							t=t..img('cards/empty.png');
						else
							t=t..img('cards/empty.png')..img('cards/spacerhor.png');
						end;
					end;
				end;
				t=t..[[^]]..img('cards/spacerver.png')..[[^]];
			end;
		end;
		t=t..[[{playagain|Сыграть снова}^
		{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam='controller',
			act=function(s,w)
				w=tonumber(w);
				local t;
				if playbayan.selected then
					if w==playbayan.selected-2 or w==playbayan.selected-1 then
						if playbayan.shuffled[playbayan.selected][1]==playbayan.shuffled[w][1] or playbayan.shuffled[playbayan.selected][2]==playbayan.shuffled[w][2] then
							set_sound('sounds/card.wav');
							playbayan.shuffled[w][1]=playbayan.shuffled[playbayan.selected][1];
							playbayan.shuffled[w][2]=playbayan.shuffled[playbayan.selected][2];
							table.remove(playbayan.shuffled, playbayan.selected);
						end;
					end;
					playbayan.selected=false;
				else
					set_sound('sounds/click.wav');
					playbayan.selected=w;
				end;
				return true;
			end;		
		},
		xact('playagain', code[[playbayan.win=false; prefs.cbayan=prefs.cbayan+1;
		prefs:store();set_sound('sounds/card.wav'); playbayan.shuffled=shuffle(playbayan.shuffled);
			playbayan.selected=false; return true;
		]]);
		xact('back', code[[set_sound('sounds/card.wav'); walk(main);]]),
	},
		
				
						
};

playgolf = xroom {
	var {
	shuffled={};
	playable={};
	stack=false;
	messages='';
	win=false;
	firstenter=true;
	};
	fading = function()
	return true, 2;
	end;
	enter=function(s)
		if s.firstenter or prefs.cgolf==0 then
			prefs.cgolf=prefs.cgolf+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;
	forcedsc=true;
	nam = [[Instead Solitaire]],
	dsc = function()
	return txtc([[Гольф]]);
end,
	xdsc = function(s)
		local x,y,t;
		t='';
		if s.win then
			t=img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..[[
			Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
			if s.win~='saved' then
				prefs.cwgolf=prefs.cwgolf+1;
				prefs:store();
				s.win='saved';
			end;
		end;
		if #s.shuffled>0 then
			t=t..[[{getbutt|]]..img('cards/backs/'..prefs.back..'.png')..[[}]];
		else
			t=t..img('cards/empty.png');
		end;
		if s.stack then
			if s.stack[1]~='e' then
				t=t..img('cards/'..prefs.theme..'/'..s.stack[1]..s.stack[2]..'.png')..[[^^]];
			else
				t=t..img('cards/empty.png')..[[^^]];
			end;
		else
			t=t..img('cards/empty.png')..[[^^]];
		end;
		if not s.win then
			for x=0,4 do
				for y=1,7 do
					if s.playable[x*7+y][1]~='e' then
						if (x*7+y+7)>35 or s.playable[(x*7+y)+7][1]=='e' then
							t=t..'{controller('..x*7+y..[[
							)|]]..img('cards/'..prefs.theme..'/'..s.playable[x*7+y][1]..s.playable[x*7+y][2]..'.png')..[[}]];
						else
							t=t..img('cards/'..prefs.theme..'/inactive/'..s.playable[x*7+y][1]..s.playable[x*7+y][2]..'.png');
						end;
					else
						t=t..img('cards/empty.png');
					end;
				end;
				t=t..[[^]];
			end;
			t=t..[[^]];
		end;
		if s.win then
			t=t..[[^]]..img('cards/spacerver.png')..[[^]];
		end;
		if #s.shuffled>0 then
			t=t..[[{getbutt|Взять карту}^]];
		else
			t=t..[[Карт больше нет^]];
		end;
		t=t..[[{rptbutt|Начать заново}^]];
		t=t..[[{back|В главное меню}^]];
		return txtc(t..[[^^]]);
	end;
	
	obj = {
	obj {
		nam='controller';
		act=function(s, w)
			local p;
			if playgolf.stack then
				p=playgolf.playable[tonumber(w)];
				if playgolf.stack[1]==p[1]-1 or playgolf.stack[1]==p[1]+1 then
					set_sound('sounds/card.wav');
					playgolf.stack[1]=playgolf.playable[tonumber(w)][1];
					playgolf.stack[2]=playgolf.playable[tonumber(w)][2];
					playgolf.playable[tonumber(w)][1]='e';
				end;
			end;
			for p=1,35 do
				if playgolf.playable[p][1]~='e' then
				return true;
				end;
			end;
			playgolf.win=true;
			return true;
		end;
	},
	obj {
		nam='getbutt';
		act=function(s)
			set_sound('sounds/card.wav');
			playgolf.stack=table.remove(playgolf.shuffled);
		return true;
		end;
	},
	obj {
		nam='rptbutt';
		act=function(s)
			prefs.cgolf=prefs.cgolf+1;
			prefs:store();
			playgolf.win=false;
			playgolf.stack=false;
			playgolf.shuffled=shuffle(playgolf.shuffled);
			playgolf.playable=getplayable(playgolf.shuffled);
			return true;
		end;
			
	},
	xact('back', code[[walk(main)]]);
	}
};

playmonte = xroom {
	var {
	shuffled={};
	selected=false;
	firstenter=true;
	win=false;
	};
	fading = function()
	return true, 2;
	end;
	enter=function(s)
		if s.firstenter or prefs.cmonte==0 then
			prefs.cmonte=prefs.cmonte+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;
	forcedsc=true;
	nam = [[Instead Solitaire]],
	dsc = function(s)
		return txtc([[Монте-Карло]]);
	end,
	xdsc = function(s)
		local x,y,t;
		t='';
		if #s.shuffled==0 then
			if not s.win then
				s.win=true;
			end;
			t=img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..[[
			Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
			if s.win==true then
				prefs.cwmonte=prefs.cwmonte+1;
				prefs:store();
				s.win='saved';
			end;
		end;
		if #s.shuffled>20 then
			t=t..img('cards/backs/'..prefs.back..'.png')..'^^';
		elseif #s.shuffled~=0 then
			t=t..img('cards/empty.png')..'^^';
		end;
		if #s.shuffled>0 then
			for x=0,3 do
				for y=1,5 do
					if s.shuffled[x*5+y] then
						if x*5+y==s.selected then
							if y==5 then
								t=t..'{controller('..x*5+y..')|'..img('cards/'..prefs.theme..[[/inactive/]]..s.shuffled[x*5+y][1]..s.shuffled[x*5+y][2]..'.png')..'}';
							else
								t=t..'{controller('..x*5+y..')|'..img('cards/'..prefs.theme..[[/inactive/]]..s.shuffled[x*5+y][1]..s.shuffled[x*5+y][2]..'.png')..'}'..img('cards/spacerhor.png');
							end;
						else
							if y==5 then
								t=t..'{controller('..x*5+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*5+y][1]..s.shuffled[x*5+y][2]..'.png')..'}';
							else
								t=t..'{controller('..x*5+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*5+y][1]..s.shuffled[x*5+y][2]..'.png')..'}'..img('cards/spacerhor.png');
							end;
						end;
					else
						if y==5 then
							t=t..img('cards/empty.png');
						else
							t=t..img('cards/empty.png')..img('cards/spacerhor.png');
						end;
					end;
				end;
				t=t..[[^]]..img('cards/spacerver.png')..[[^]];
			end;
		end;
		t=t..[[{playagain|Сыграть снова}^
		{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam='controller',
			act=function(s,w)
				w=tonumber(w);
				local t, passed;
				passed=false;
				t=playmonte.selected;
				if playmonte.selected then
					if t==1 then
						if w==2 or
						w==6 or
						w==7 then
							passed=true;
						end;
	
					elseif t==5 then
						if w==4 or
						w==9 or
						w==10 then
							passed=true;
						end;
	
					elseif t==16 then
						if w==17 or
						w==11 or
						w==12 then
							passed=true;
						end;
					elseif t==20 then
						if w==19 or
						w==15 or
						w==14 then
							passed=true;	
						end;
					elseif t==2 or t==3 or t==4 then
						if w==t-1 or w==t+1 or w==t+4 or w==t+5 or w==t+6 
						then
							passed=true;	
						end;
					elseif t==17 or t==18 or t==19 then
						if w==t-1 or w==t+1 or w==t-4 or w==t-5 or w==t-6 
						then
							passed=true;	
						end;
					elseif t==6 or t==11 then
						if w==t+5 or w==t+1 or w==t-4 or w==t-5 or w==t+6
						then
							passed=true;	
						end;
					elseif t==10 or t==15 then
						if w==t-1 or w==t-5 or w==t-6 or w==t+4 or w==t+5 
						then
							passed=true;	
						end;
					elseif t==7 or t==8 or t==9 or
					t==12 or t==13 or t==14 then
						if w==t+1 or
						w==t-1 or
						w==t+4 or
						w==t-4 or
						w==t+5 or 
						w==t-5 or
						w==t+6 or 
						w==t-6 then
							passed=true;
						end;	
					end;
					if passed==true then
						if playmonte.shuffled[playmonte.selected][1]==playmonte.shuffled[w][1] or playmonte.shuffled[playmonte.selected][2]==playmonte.shuffled[w][2] then
							set_sound('sounds/card.wav');
							table.remove(playmonte.shuffled, w);
							if playmonte.selected>w then
								table.remove(playmonte.shuffled, playmonte.selected-1);
							else
								table.remove(playmonte.shuffled, playmonte.selected);
							end;
						end;
					end;
					playmonte.selected=false;
				else
					set_sound('sounds/click.wav');
					playmonte.selected=w;
				end;
				return true;
			end;		
		},
		xact('playagain', code[[playmonte.win=false; prefs.cmonte=prefs.cmonte+1;
		prefs:store();set_sound('sounds/card.wav'); playmonte.shuffled=shuffle(playmonte.shuffled);
			playmonte.selected=false; return true;
		]]);
		xact('back', code[[set_sound('sounds/card.wav'); walk(main);]]),
	},
		
				
						
};

playoldfriend = xroom {
	var {
	firstenter=true;
	shuffled={};
	stack={{},{},{},{},{}}; --1
	finalstack={};
	messages='';
	selected=false;
	win=false;
	};
	fading = function()
	return true, 2;
	end;
	enter=function(s)
		if s.firstenter or prefs.coldfriend==0 then
			prefs.coldfriend=prefs.coldfriend+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;
	forcedsc=true;
	nam = [[Instead Solitaire]],
	dsc = function()
		return txtc([[Старый друг]]);
	end,
	xdsc = function(s)
		local x,y,t;
		t=[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
		if #s.finalstack==52 then
			if s.win==false then
				s.win=true;
			end;
			t=t..[[Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]];
			t=t..img('cards/'..prefs.theme..'/'..s.finalstack[#s.finalstack][1]..s.finalstack[#s.finalstack][2]..'.png')..'^'..img('cards/spacerver.png')..'^';
			t=t..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]
			t=t..[[^^{tryagain|Сыграть снова}^{back|В главное меню}]];
			if s.win==true then
				prefs.cwoldfriend=prefs.cwoldfriend+1;
				prefs:store();
				s.win='saved';
			end;
			return txtc(t);
		end;
		if #s.shuffled>0 then
			t=t..'{getcard|'..img('cards/backs/'..prefs.back..'.png')..'}'..img('cards/spacerhor.png');
		else
			t=t..img('cards/empty.png')..img('cards/spacerhor.png');
		end;
		if #s.stack[1]>0 then
			if s.selected==1 then
				t=t..'{controller(1)|'..img('cards/'..prefs.theme..'/inactive/'..s.stack[1][#s.stack[1]][1]..s.stack[1][#s.stack[1]][2]..'.png')..'}'..img('cards/spacerhor.png');
			else
				t=t..'{controller(1)|'..img('cards/'..prefs.theme..'/'..s.stack[1][#s.stack[1]][1]..s.stack[1][#s.stack[1]][2]..'.png')..'}'..img('cards/spacerhor.png');
			end;
		else
			t=t..img('cards/empty.png')..img('cards/spacerhor.png');
		end;
		t=t..img('cards/empty.png')..img('cards/spacerhor.png');
		if #s.finalstack>0 then
			t=t..img('cards/'..prefs.theme..'/'..s.finalstack[#s.finalstack][1]..s.finalstack[#s.finalstack][2]..'.png')..'^'..img('cards/spacerver.png')..'^';
		else
			t=t..img('cards/empty.png')..'^'..img('cards/spacerver.png')..'^';
		end;
		for x=2,5 do
			if #s.stack[x]>0 then
				if x==s.selected then
					t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/inactive/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}';
				else
					t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}';
				end;
				if x~=5 then
					t=t..img('cards/spacerhor.png');
				end;
			else
				t=t..img('cards/spacerhor.png')..img('cards/empty.png');
			end;
		end;
		t=t..[[^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]
		t=t..[[^^{tryagain|Сыграть снова}^{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam='controller';
			act=function(s,w)
				w=tonumber(w);
				if playoldfriend.selected then
					if w~=playoldfriend.selected then
						if playoldfriend.stack[w][#playoldfriend.stack[w]][1]+playoldfriend.stack[playoldfriend.selected][#playoldfriend.stack[playoldfriend.selected]][1]==13 then
							set_sound('sounds/card.wav');
							table.insert(playoldfriend.finalstack, table.remove(playoldfriend.stack[playoldfriend.selected]));
							table.insert(playoldfriend.finalstack, table.remove(playoldfriend.stack[w]));
							if #playoldfriend.stack[w]==0 then
								if #playoldfriend.shuffled>0 then
									table.insert(playoldfriend.stack[w], table.remove(playoldfriend.shuffled));
								end;
							end;
							if #playoldfriend.stack[playoldfriend.selected]==0 then
								if #playoldfriend.shuffled>0 then
									table.insert(playoldfriend.stack[playoldfriend.selected], table.remove(playoldfriend.shuffled));
								end;
							end;
						end;
					end;
					playoldfriend.selected=false;
				else
					if playoldfriend.stack[w][#playoldfriend.stack[w]][1]~=13 then
						set_sound('sounds/card.wav');
						playoldfriend.selected=w;
					else
						set_sound('sounds/card.wav');
						table.insert(playoldfriend.finalstack, table.remove(playoldfriend.stack[w]));
						if #playoldfriend.stack[w]==0 then
							if #playoldfriend.shuffled>0 then
								table.insert(playoldfriend.stack[w], table.remove(playoldfriend.shuffled));
							end;
						end;
					end;
				end;
				return true;
			end;
		},
		xact('getcard', code[[
			table.insert(playoldfriend.stack[1], table.remove(playoldfriend.shuffled));
		]]);
		xact('tryagain', code[[prefs.coldfriend=prefs.coldfriend+1;
		prefs:store(); playoldfriend.win=false; playoldfriend.selected=false; set_sound('sounds/click.wav'); playoldfriend.shuffled=shuffle_36(play2x2.shuffled);
		playoldfriend.finalstack={};
		local i;
		playoldfriend.stack[1]={};
		for i=2,5 do
			for j=1,5 do
				table.insert(playoldfriend.stack[i], table.remove(playoldfriend.shuffled));
			end;
		end;
		return true;]]);
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]);
	};
};

playpairs = xroom {
	var {
		shuffled={};
		stack={};
		selected=false;
		firstenter=true;
		win=false;
		testwin=true;
	};
	
	fading = function()
	return true, 2;
	end;
	enter=function(s)
		if s.firstenter or prefs.cpairs==0 then
			prefs.cpairs=prefs.cpairs+1;
			prefs:store();
			s.firstenter=false;
		end;
	end;
	forcedsc = true;
	nam = [[Instead Solitaire]],
	dsc = function()
		return txtc([[Пары]]);
	end,
	xdsc = function(s)
		local x, t;
		t=img('cards/spacerver.png')..[[^]];
		for x=1,9 do
			if #s.stack[x]>0 then
				s.testwin=false;
				break;
			else
				s.testwin=true;
			end;
		end;
		if s.testwin then
			if not s.win then
				s.win=true;
			end;
			if s.win==true then
				s.win='saved';
				prefs.cwpairs=prefs.cwpairs+1;
				prefs:store();
			end;
			t=t..img('cards/spacerver.png')..[[^]]..[[
			Поздравляю, вы победили!^]]..img('cards/spacerver.png')..[[^]];
		end;
		if not s.win then
			for x=1,9 do
				if #s.stack[x]>0 then
					if x==s.selected then
						if x==3 or x==6 or x==9 then
							t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/inactive/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}';
						else
							t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/inactive/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}'..img('cards/spacerhor.png');
						end;
					else
						if x==3 or x==6 or x==9 then
							t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}';
						else
							t=t..'{controller('..x..')|'..img('cards/'..prefs.theme..'/'..s.stack[x][#s.stack[x]][1]..s.stack[x][#s.stack[x]][2]..'.png')..'}'..img('cards/spacerhor.png');
						end;
					end;
				else
					if x==3 or x==6 or x==9 then
						t=t..img('cards/empty.png');
					else
						t=t..img('cards/empty.png')..img('cards/spacerhor.png');
					end;
				end;
				if x==3 or x==6 then
					t=t..[[^]]..img('cards/spacerver.png')..[[^]];
				end;
			end;
			t=t..[[^]]..img('cards/spacerver.png')..[[^]];
		end;
		t=t..[[^^{tryagain|Сыграть снова}^{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam = 'controller',
			act = function(s,w)
				w=tonumber(w);
				if playpairs.selected then
					if w~=playpairs.selected then
						if playpairs.stack[w][#playpairs.stack[w]][1]==playpairs.stack[playpairs.selected][#playpairs.stack[playpairs.selected]][1] then
							set_sound('sounds/card.wav');
							table.remove(playpairs.stack[w]);
							table.remove(playpairs.stack[playpairs.selected]);
						end;
					end;
					playpairs.selected=false;
				else
					set_sound('sounds/click.wav');
					playpairs.selected=w;
				end;
				return true;
			end,
		},
		xact('tryagain', code[[prefs.cpairs=prefs.cpairs+1;
				prefs:store();playpairs.win=false;
		playpairs.testwin=true; playpairs.selected=false;set_sound('sounds/click.wav');
			playpairs.shuffled=shuffle_36(playpairs.shuffled);
			playpairs.stack=getpairs(playpairs.shuffled);
			return true;
		]]);
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]);
	}
};

playpam = xroom {
	var {
		shuffled={};
		selected1=false;
		selected2=false;
		win=false;
		tim=0;
		steps=0;
		started=false;
		wincnt=0;
	};
	ini = function(s)
		game_start = os.time() - seconds;
	end;
	timer = function(s)
		seconds = s.tim + os.time() - game_start;
	end;
	fading = function()
	return true, 2;
	end;
	enter = function(s)
		if s.started then
			timer:set(1000);
			game_start = os.time();
		end;
	end;
	exit = function(s) 
		if s.started then
			timer:stop();
			s.tim=seconds;
		end;
	end;
	forcedsc = true;
	nam = function(s)
		return [[Instead Solitaire]];
		end;
	dsc = function(s)
		return txtc([[Память]]);
	end,
	xdsc = function(s)
		local x,y,t;
		t='';
		s.wincnt=0;
		for x=1,52 do
			if s.shuffled[x] then
				break;
			else
				s.wincnt=s.wincnt+1;
			end;
		end;
		if s.wincnt==52 then
			if not s.win then
				s.win=true;
			end;
			timer:stop();
			t=img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..[[
			Поздравляю, вы победили!^Ваше время: ]]..seconds..' секунд.^'..[[Шагов: ]]..s.steps..'^'..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]];
			if s.win==true then
				prefs.cwmemory=prefs.cwmemory+1;
				if prefs.csmemory1>s.steps or prefs.csmemory1==0  then
					prefs.csmemory1=tonumber(s.steps);
					prefs.ctmemory1=tonumber(seconds);
					t=t..[[Вы установили рекорд по количеству шагов!]]..[[^]]..img('cards/spacerver.png')..[[^]];
				elseif prefs.ctmemory2>seconds or prefs.ctmemory2==0 then
					prefs.csmemory2=tonumber(s.steps);
					prefs.ctmemory2=tonumber(seconds);
					t=t..[[Вы установили рекорд по времени!]]..[[^]]..img('cards/spacerver.png')..[[^]];
				elseif (prefs.csmemory1>s.steps or prefs.csmemory1==0) and (prefs.ctmemory2>seconds or prefs.ctmemory2==0) then
					prefs.csmemory1=tonumber(s.steps);
					prefs.ctmemory1=tonumber(seconds);
					prefs.csmemory2=tonumber(s.steps);
					prefs.ctmemory2=tonumber(seconds);
					t=t..[[Вы установили абсолютный рекорд!]]..[[^]]..img('cards/spacerver.png')..[[^]];
				end;
				prefs:store();
				s.win='saved';
			end;
			timer:stop();
		end;
		if not s.win then
			for x=0,5 do
				for y=1,10 do
					if s.shuffled[x*10+y] then
						if s.started then
							if x*10+y==s.selected1 or x*10+y==s.selected2 then
								if y==10 then
									t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}';
								else
									t=t..'{controller('..x*10+y..')|'..img('cards/'..prefs.theme..[[/]]..s.shuffled[x*10+y][1]..s.shuffled[x*10+y][2]..'.png')..'}'..img('cards/spacerhor.png');
								end;
							else
								if y==10 then
									t=t..'{controller('..x*10+y..')|'..img('cards/backs/'..prefs.back..'.png')..'}';
								else
									t=t..'{controller('..x*10+y..')|'..img('cards/backs/'..prefs.back..'.png')..'}'..img('cards/spacerhor.png');
								end;
							end;
						else
							if y==10 then
								t=t..img('cards/backs/'..prefs.back..'.png');
							else
								t=t..img('cards/backs/'..prefs.back..'.png')..img('cards/spacerhor.png');
							end;
						end;
					else
						if y==10 then
							t=t..img('cards/empty.png');
						else
							t=t..img('cards/empty.png')..img('cards/spacerhor.png');
						end;
					end;
				end;
				t=t..[[^]]..img('cards/spacerver.png')..[[^]];
			end;
		end;
		if not s.started then
			t=t..[[{start|Начать}^]];
		elseif s.started and not s.win then
			t=t..[[Шагов: ]]..s.steps..'^';
		end;
		t=t..[[{playagain|Заново}^
		{back|В главное меню}]];
		return txtc(t);
	end;
	obj = {
		obj {
			nam='controller',
			act=function(s,w)
				w=tonumber(w);
				if playpam.selected1 and not playpam.selected2 then
					if w~=playpam.selected1 then
						if playpam.shuffled[playpam.selected1][1]==playpam.shuffled[w][1] then
							set_sound('sounds/card.wav');
							playpam.shuffled[w]=false;
							playpam.shuffled[playpam.selected1]=false;
							playpam.selected1=false;
							playpam.selected2=false;
						else
							playpam.selected2=w;
						end;
					else
						playpam.selected1=false;
					end;
					playpam.steps=playpam.steps+1;
				elseif playpam.selected1 and playpam.selected2 then
					playpam.selected1=w;
					playpam.selected2=false;
				elseif playpam.selected1==false and playpam.selected2==false then
					set_sound('sounds/click.wav');
					playpam.selected1=w;
				end;
				return true;
			end;		
		},
		xact('start',code[[game_start = os.time();  prefs.cmemory=prefs.cmemory+1;
					timer:set(1000); playpam.started=true; return true;]]),
		xact('playagain', code[[timer:stop();
					seconds = 0; playpam.win=false; playpam.started=false; playpam.steps=0; playpam.tim=0; playpam.wincnt=0;
		prefs:store();set_sound('sounds/card.wav'); playpam.shuffled=shuffle(playpam.shuffled);
			playpam.selected1=false; playpam.selected2=false;  return true;
		]]);
		xact('back', code[[set_sound('sounds/card.wav'); walk(main);]]),
	},
	
};

about = room {
	fading = function()
	return true, 2;
	end;
	var {
	alphabet=0;
	};
	forcedsc=true;
	nam = [[О программе]],
	disp = img('theme/insol.png'),
	dsc = function(s)
		local t;
		t=txtc(txtu([[Идея, реализация, графика]]))..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[excelenter (e-mail: excelenter@yandex.ru; jid: excelenter@jabber.ru).
				^Использованы фотографии из открытых источников;^
				Использованы паттерны: Evan Eckard (http://www.dinpattern.com/).]]..img('cards/spacerver.png')..[[^
				]]..img('cards/spacerver.png')..[[^^]]..txtc(txtu([[Музыка]]))..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[
			"Afro Superfly" -- marwin / noice;^
			"Capehorn" -- Reed Richards;^
			"Softjazz Club" -- blasa;^
			"Alleycat" -- Jakim;^
			"La Blue Girl" -- Radix.^^]]..txtc(txtu([[Другое]]))..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[Если есть, что сказать -- пишите либо в ветку на форуме
				(http://instead.syscall.ru/forum), либо на e-mail, либо в jabber. 		
				]]..img('cards/spacerver.png')..[[^
				]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^]]..txtc([[{back|Назад}]]);
		return txtl(t);
	end,
	obj = {
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]),
	},
};

chgame = room {
	fading = function()
	return true, 2;
	end;
	nam = [[Выбор игры]],
	disp = img('theme/insol.png'),
	dsc = function()
		local t;
		t=[[^{monte|Монте-Карло}^^{2x2|Дважды два}^^{old|Старый друг}^^{mem|Память}^^{bayan|Баян}^^{pairs|Пары}^^{golf|Гольф}^^]];
		t=t..[[{back|Назад}]];
		return txtc(t);
		end;
	obj = {
		xact('golf', code[[set_sound('sounds/click.wav');walk(playgolf)]]);
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]);
		xact('monte', code[[set_sound('sounds/click.wav');walk(playmonte)]]);
		xact('pairs', code[[set_sound('sounds/click.wav');walk(playpairs)]]);
		xact('2x2', code[[set_sound('sounds/click.wav');walk(play2x2)]]);
		xact('bayan', code[[set_sound('sounds/click.wav');walk(playbayan)]]);
		xact('mem', code[[set_sound('sounds/click.wav'); walk(playpam)]]);
		xact('old', code[[set_sound('sounds/click.wav');walk(playoldfriend)]])
	
	};
};

help = room {
	fading = function()
	return true, 2;
	end;
	nam = [[Помощь]],
	disp = img('theme/insol.png'),
	dsc = function(s)
		local t;
		t=[[{rules|Правила игр}^^
			{mhlp|Общая справка}^^
			{back|Назад}]]
		return txtc(t);
	end,
	obj = {
		xact('rules', code[[set_sound('sounds/click.wav');walk(rules)]]),
		xact('mhlp', code[[set_sound('sounds/click.wav');walk(mainhelp)]]),
		xact('back', code[[
			set_sound('sounds/click.wav');walk(main);
		]]),
	},
};

mainhelp = room {
	fading = function()
	return true, 2;
	end;
	nam = [[Общая справка]],
	disp = img('theme/insol.png'),
	dsc = function()
		local t;
		t=txtem([[Об игре:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[Эта игра является сборником карточных игр. 
				Сюда входят: "Монте-Карло", "Дважды два", "Старый друг", "Память", "Пары", "Баян" и "Гольф"]];
		t=t..[[. Вы можете ознакомиться с правилами каждой игры, перейдя по {ruls|этой ссылке}.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Статистика:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[Игра собирает статистику по мере активности игрока. Вы можете просмотреть
				ее, перейдя по {stats|этой ссылке}, либо перейдя из главного меню в раздел "Статистика".^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Настройки:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[Вы можете настроить внешний вид игры. Доступные параметры: набор карт, рубашка карт,
				фоновая музыка. Вы можете настроить их по своему вкусу на странице "{pr|Настройки}".^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Другое:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..[[Если Вы выходите из игры в главное меню, прогресс не сбрасывается. Прогресс сбрасывается автоматически только при
				перезапуске игры.^Игра жестока в том смысле, что не указывает явно, проиграли Вы или нет 
				(Впрочем, кто Вам это укажет в пасьянсе, как не Вы сами?).]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		return txtl(t)..txtc([[{back|Назад}^{tomain|В главное меню}]]);
		end;
	obj = {
		xact('stats', code[[set_sound('sounds/click.wav');walk(stat)]]),
		xact('pr', code[[set_sound('sounds/click.wav');walk(scroptions)]]),
		xact('ruls', code[[set_sound('sounds/click.wav');walk(rules)]]),
		xact('back', code[[set_sound('sounds/click.wav');walk(help)]]),
		xact('tomain', code[[set_sound('sounds/click.wav');walk(main)]]),
	
	}
};

rules = room {
	fading = function()
	return true, 2;
	end;
	nam = [[Правила игр]],
	disp = img('theme/insol.png'),
	dsc = function()
		local t;
		t=txtem([[Монте-Карло:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ удаление карт со всех рядов.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Карты выкладываются лицом вверх в 4 ряда по 5 карт в каждом. 
				Карты одного значения либо карты одной масти, которые лежат рядом друг с другом, 
				либо по диагонали удаляются. После удаления пустые места заполняются картами из нижних 
				рядов, а их места занимают карты, которые докладываются из колоды. Пасьянс сходится, 
				когда не остается ни одной карты.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Дважды два:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ разложить все карты из колоды.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Из колоды берутся 4 карты и кладутся рядом картинкой вверх. 
				Если попадутся 2 карты одинаковой масти, то они покрываются 2 картами из колоды. 
				Пасьянс сойдется в том случае, если выйдет вся колода.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Старый друг:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ собрать все карты в одной стопке.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Колода состоит из 52 карт. На столе раскладываются 4 
				стопки по 5 карт в каждой мастью вверх. Далее смотрят, нет ли верхних 2 карт, число 
				которых в сумме составило бы 13. Если есть, то эти карты откладываются в сторону 
				(король, дама и туз, валет и 2, 10 и 3 и т.д.). Если возможности исчерпаны, из 
				оставшейся колоды открывается верхняя карта и кладется рядом. Если есть комбинация из 
				2 карт равная 13, то она также откладывается в сторону, если нет - открывается следующая 
				карта из оставшейся колоды. Пасьянс сойдется, если все карты соберутся в одной стопке.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Память:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ открыть все карты за минимальное количество ходов..^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Колода тщательно тасуется, снимается и выкладывается
				в закрытом виде. Первым ходом можно открыть любую карту, далее тоже можно 
				открыть любую карту, если карты будут одного значения, то они откладываются в сторону.
				Если карты будут разного значения, то карты закрываются и игрок вновь открывает
				карты одну за одной. Итак до тех пор, пока не будут открыты все карты. Цель игрока играя в данный 
				пасьянс, это за минимальное количество ходов открыть все карты. Необходимо запоминать в процессе 
				игры, где какие карты лежат.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Пары:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ снять все 18 пар карт с 9 стопок.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Колода из 36 карт раскладывается на 9 стопок по 4 
				в каждой рубашкой вверх. Верхние карты открываются. 
				Если попадутся какие-либо 2 карты одинакового достоинства, то их нужно отложить в сторону. 
				Пасьянс сойдется в том случае, если снять все 18 пар карт (т.е. всю колоду).^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Баян:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ собрать все карты в одну стопку.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ Колода из 52 карт выкладывается в 6 горизонтальных рядов
				(Точнее в один большой ряд. На экране попросту места не хватает).^
				Если карта лежит справа от карты той же масти или достоинства (рядом или через одну карту), 
				то она кладется на левую карту. Собранные одна на другую карты перекладываются стопкой. 
				Освободившиеся места заполняются сдвигом оставшихся стопок влево. Считается, что разложить этот пасьянс достаточно
				тяжело.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		t=t..txtem([[Гольф:]])..[[^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Цель:')..[[ необходимо собрать все карты в 
				базовой ячейке в восходящей последовательности без учета масти.^
				]]..img('cards/spacerver.png')..[[^]]..txtu('Правила:')..[[ колода тщательно тасуется, 
				снимается и выкладывается 7 рядов по 5 карт в каждом ряду в открытом виде.
				Это игровые карты. Оставшаяся колода кладется сверху и рядом с
				ней располагается базовая ячейка для карт. Разрешается 
				перемещать в ячейку возле колоды открытые карты игровых 
				рядов в восходящей или нисходящей последовательности без учета 
				масти. На тузы разрешается выкладывать только двойки. Карты 
				перемещаются по одной. Пасьянс сошелся, если все карты собраны 
				на базовой ячейке.^]]..img('cards/spacerver.png')..[[^]]..img('cards/spacerver.png')..[[^^]];
		return txtl(t)..txtc([[{back|Назад}^{tomain|В главное меню}]]);
		end;
	obj = {
		xact('back', code[[set_sound('sounds/click.wav');walk(help)]]),
		xact('tomain', code[[set_sound('sounds/click.wav');walk(main)]]),
	
	}
};

scroptions = room {
	forcedsc=true;
	fading = function()
		return true, 2;
	end;
	nam = [[Настройки]],
	disp = img('theme/insol.png'),
	dsc = function(s)
		local t;
		t='';
		if bgroundm then
			t=t..[[{selectbground|]]..img('theme/minus.png')..[[ Выбор фона}^]];
		else
			t=t..[[{selectbground|]]..img('theme/plus.png')..[[ Выбор фона}^]];
		end;

		if bgroundm then
			local i;
			for i=1, #bgrounds do
				if i == prefs.bground then
					t=t..[[{selbg(]]..i..[[)|]]..img("pad:4,"..ret_thumb(i)..";box:62x5,#d8ff00,10@0,42;"..
					[[box:62x5,#d8ff00,10@0,0;box:5x37,#d8ff00,10@0,5;box:5x37,#d8ff00,10@57,5;
					]])..[[}]];
				else
					t=t..[[{selbg(]]..i..[[)|]]..img("pad:4,"..ret_thumb(i))..[[}]];
				end;
			end;
			t=t..[[^^]];
		end;

		if cardsm then
			t=t..[[{selectcards|]]..img('theme/minus.png')..[[ Выбор карт}]];
		else
			t=t..[[{selectcards|]]..img('theme/plus.png')..[[ Выбор карт}]];
		end;
		if cardsm then
			if prefs.theme=='modern_black' then
				t=t..[[^]]..[[ {selob|]]..img('theme/radio.png')..[[ Модерн}]]..[[^
				]]..[[ {selminima|]]..img('theme/radioon.png')..[[ Модерн(черные)}^
				{selinspiration|]]..img('theme/radio.png')..[[ Вдохновение}^]];
			elseif prefs.theme=='modern' then
				t=t..[[^]]..[[ {selob|]]..img('theme/radioon.png')..[[ Модерн}]]..[[^
				]]..[[ {selminima|]]..img('theme/radio.png')..[[ Модерн(черные)}^
				{selinspiration|]]..img('theme/radio.png')..[[ Вдохновение}^]];
			else
				t=t..[[^]]..[[ {selob|]]..img('theme/radio.png')..[[ Модерн}]]..[[^
				]]..[[ {selminima|]]..img('theme/radio.png')..[[ Модерн(черные)}^
				{selinspiration|]]..img('theme/radioon.png')..[[ Вдохновение}^]];
			end;
		end;
		if backm then
			t=t..[[^{selectback|]]..img('theme/minus.png')..[[ Выбор рубашки}^]];
		else
			t=t..[[^{selectback|]]..img('theme/plus.png')..[[ Выбор рубашки}^]];
		end;
		if backm then
			local i,d;
			if prefs.theme=='inspiration' then
				d=20;
				if prefs.back<20 then
					prefs.back=prefs.back+20;
				end;
			else
				d=0;
				if prefs.back>=20 then
					prefs.back=prefs.back-20;
				end;
			end;
			t=t..img('cards/spacerver.png')..[[^]];
			for i=d,d+19 do
				if prefs.back==i then
					t=t..[[ {selback(]]..i..[[)|]]..img('cards/backs/'..i..'.png')..[[} ]];
				else
					t=t..[[ {selback(]]..i..[[)|]]..img('cards/backs/inactive/'..i..'.png')..[[} ]];
				end;
				if i==9 or i==29 then
					t=t..[[^]]..img('cards/spacerver.png')..[[^]];
				end;
			end;
			t=t..[[^^]];
		end;
		if musm then
			t=t..[[{selectmusic|]]..img('theme/minus.png')..[[ Выбор музыки}]];
		else
			t=t..[[{selectmusic|]]..img('theme/plus.png')..[[ Выбор музыки}]];
		end;
		if musm then	--Sorry for ugly code $)
			if prefs.music=='off' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radioon.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radio.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radio.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radio.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radio.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radio.png')..[[ La Blue Girl}]];
			elseif prefs.music=='afro_superfly.xm' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radio.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radioon.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radio.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radio.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radio.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radio.png')..[[ La Blue Girl}]];
			elseif prefs.music=='capehorn.xm' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radio.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radio.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radioon.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radio.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radio.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radio.png')..[[ La Blue Girl}]];
			elseif prefs.music=='blasa-softjazz_club.it' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radio.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radio.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radio.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radioon.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radio.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radio.png')..[[ La Blue Girl}]];
			elseif prefs.music=='jk_groovy.xm' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radio.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radio.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radio.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radio.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radioon.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radio.png')..[[ La Blue Girl}]];
			elseif prefs.music=='la_blue_girl.xm' then
				t=t..[[^]]..[[ {musoff|]]..img('theme/radio.png')..[[ Без музыки}]]..[[^
				]]..[[ {musafro|]]..img('theme/radio.png')..[[ Afro Superfly}]]..[[^
				]]..[[ {muscapehorn|]]..img('theme/radio.png')..[[ Capehorn}]]..[[^
				]]..[[ {mussoftclub|]]..img('theme/radio.png')..[[ SoftJazz Club}]]..[[^
				]]..[[ {musalleycat|]]..img('theme/radio.png')..[[ Alleycat}]]..[[^
				]]..[[ {musfunk|]]..img('theme/radioon.png')..[[ La Blue Girl}]];
			end;
		end;
		t=t..[[^^{back|Назад}]];
		return txtl(t);
	end;
	obj = {
		xact('selectbground', code[[set_sound('sounds/click.wav');
			if bgroundm then
				bgroundm=false;
			else
				bgroundm=true;
				cardsm = false;
				backm = false;
				musm = false;
			end;	
			return true;
		]]),
		xact('selectcards', code[[set_sound('sounds/click.wav');
			if cardsm then
				cardsm=false;
			else
				cardsm=true;
				bgroundm = false;
				backm = false;
				musm = false;
			end;
			return true;
		]]),
		xact('selectback', code[[set_sound('sounds/click.wav');
			if backm then
				backm=false;
			else
				backm=true;
				cardsm = false;
				bgroundm = false;
				musm = false;
			end;
			return true;
		]]),
		xact('selob', code[[set_sound('sounds/click.wav');
			prefs.theme='modern';
			return true;
		]]),
		xact('selminima', code[[set_sound('sounds/click.wav');
			prefs.theme='modern_black';
			return true;
		]]),
		xact('selinspiration', code[[set_sound('sounds/click.wav');
			prefs.theme='inspiration';
			return true;
		]]),
		xact('back', code[[set_sound('sounds/click.wav');
			walk(main);
		]]),
		xact('selectmusic', code[[set_sound('sounds/click.wav');
			if musm then
				musm=false;
			else 
				musm=true;
				backm = false;
				cardsm = false;
				bgroundm = false;
			end;
			return true;
		]]),
		xact('musoff', code[[set_sound('sounds/click.wav');
			prefs.music='off';
			return true;
		]]),
		xact('musafro', code[[set_sound('sounds/click.wav');
			prefs.music='afro_superfly.xm';
			return true;
		]]),
		xact('muscapehorn', code[[set_sound('sounds/click.wav');
			prefs.music='capehorn.xm';
			return true;
		]]),
		xact('mussoftclub', code[[set_sound('sounds/click.wav');
			prefs.music='blasa-softjazz_club.it';
			return true;
		]]),
		xact('musalleycat', code[[set_sound('sounds/click.wav');
			prefs.music='jk_groovy.xm';
			return true;
		]]),
		xact('musfunk', code[[set_sound('sounds/click.wav');
			prefs.music='la_blue_girl.xm';
			return true;
		]]),
		obj {
			nam='selback';
			act=function(s,w)
				prefs.back=tonumber(w);
				return true;
			end;
		},
		obj {
			nam = 'selbg',
			act = function(s, w)
				prefs.bground = tonumber(w);
				set_bground();
				return true;
			end,
		},
	},
	exit = function()
		if prefs.theme=='inspiration' then
			if prefs.back<20 then
					prefs.back=prefs.back+20;
			end;
		else
			if prefs.back>=20 then
				prefs.back=prefs.back-20;
			end;
		end;
		prefs:store();
	end;
};

stat = room {
	forcedsc=true;
	fading = function()
	return true, 2;
	end;
	nam = [[Статистика]],
	disp = img('theme/insol.png'),
	dsc = function(s)
		local t;
		t=txtc(txtu([[Общая статистика: ^]]));
		t=t..txtl([[Игра запущена, раз: ]]..prefs.execute..[[^^^]]);
		t=t..txtc(txtu([[Статистика по играм: ^]]));
		t=t..txtem([[^Монте-Карло:]])..[[ ^Количество попыток: ]]..prefs.cmonte;
		t=t..[[^Из них успешных: ]]..prefs.cwmonte..[[^^]];
		t=t..txtem([[Дважды два:]])..[[ ^Количество попыток: ]]..prefs.c2x2;
		t=t..[[^Из них успешных: ]]..prefs.cw2x2..[[^^]];
		t=t..txtem([[Старый друг:]])..[[ ^Количество попыток: ]]..prefs.coldfriend;
		t=t..[[^Из них успешных: ]]..prefs.cwoldfriend..[[^^]];
		t=t..txtem([[Память:]])..[[ ^Количество попыток: ]]..prefs.cmemory;
		t=t..[[^Из них закончено: ]]..prefs.cwmemory..[[^]]..img('cards/spacerver.png');
		t=t..[[^Лучший результат по кол-ву шагов: ]];
		t=t..[[^Время: ]]..prefs.ctmemory1..[[ секунд]];
		t=t..[[^Шаги: ]]..prefs.csmemory1..[[^]]..img('cards/spacerver.png');
		t=t..[[^Лучший результат по времени: ]];
		t=t..[[^Время: ]]..prefs.ctmemory2..[[ секунд]];
		t=t..[[^Шаги: ]]..prefs.csmemory2..[[^^]];
		t=t..txtl(txtem([[Пары:]])..[[ ^Количество попыток: ]]..prefs.cpairs);
		t=t..[[^Из них успешных: ]]..prefs.cwpairs..[[^^]];
		t=t..txtem([[Баян:]])..[[ ^Количество попыток: ]]..prefs.cbayan;
		t=t..[[^Из них успешных: ]]..prefs.cwbayan..[[^^]];
		t=t..txtem([[Гольф:]])..[[ ^Количество попыток: ]]..prefs.cgolf;
		t=t..[[^Из них успешных: ]]..prefs.cwgolf..[[^^]];
		t=t..txtc([[{clear|Очистить статистику}^{back|Назад}]]);
		return txtl(t);
	end;
		
	obj = {
		xact('back', code[[set_sound('sounds/click.wav');walk(main)]]);
		xact('clear', code[[set_sound('sounds/click.wav'); 
		prefs.c2x2=0;
		prefs.cgolf=0;
		prefs.cmonte=0;
		prefs.cpairs=0;
		prefs.cwgolf=0;
		prefs.cwmonte=0;
		prefs.cw2x2=0;
		prefs.cwpairs=0;
		prefs.cbayan=0;
		prefs.cwbayan=0;
		prefs.cwoldfriend=0;
		prefs.coldfriend=0;
		prefs.execute=1;
		prefs.cmemory=0;
		prefs.cwmemory=0;
		prefs.csmemory1=0;
		prefs.csmemory2=0;
		prefs.ctmemory1=0;
		prefs.ctmemory2=0;
		prefs:store();
		return true;
		]]);
	};
};

bgm_ctrl = obj {
	nam = true,
	life = function()
		if prefs.music~='off' then
			set_music('music/'..prefs.music);
		else
			set_music();
		end;
	end;
	
	
};

