-- $Name:Пасьянс Instead$
-- $Version:0.9.4$
-- $Author:excelenter$

-- И вот, я вернулся к старым пасьянсам.
game.dsc = [[Пасьянсы на INSTEAD. ]];

instead_version "1.4.4"

require "xact"
require "dash"
require "prefs"
require "timer"
require "theme";

if stead.version < "1.5.3" then
	walk = _G["goto"]
	walkin = goin
	walkout = goout
	walkback = goback
end

game.codepage = 'UTF-8';			
game_start = 0

dofile('func.lua');
dofile('game.lua');

-- Не очень уже помню для чего переменные
-- cardsm, musm, backm, bgroundm -- скрытие раскрытие меню 
-- tim -- таймер 
-- seconds -- ?
-- bgrounds --	задние фоны

global {
	cardsm=false;
	musm=false;
	backm=false;
	bgroundm=false;
	tim=0;
	seconds = 0;

	-- список фонов
	bgrounds = {
		'default',
		'chocolate',
		'avalon',
		'fronds',
		'regal'
	};
}

game.timer = function(s)
	tim=tim+1;
end;

-- Быдлокод. Определение переопределение настроек
function start()
	if not visited(main) then
		prefs:purge();
	end

	if not prefs.theme then
		prefs.theme='modern';
	end;

	if not prefs.music then
		prefs.music='afro_superfly.xm';
	end;

	if not prefs.back then
		prefs.back=0;
	end;

	if not prefs.bground then
		prefs.bground = 1;
	end;

	if not prefs.c2x2 or
	not prefs.cgolf or
	not prefs.cmonte or
	not prefs.cpairs or
	not prefs.cwgolf or
	not prefs.cwmonte or
	not prefs.cw2x2 or
	not prefs.cwpairs or
	not prefs.cbayan or 
	not	prefs.cwbayan or
	not prefs.cwoldfriend or
	not prefs.coldfriend or
	not prefs.cmemory or
	not prefs.cwmemory or
	not prefs.csmemory1 or
	not prefs.ctmemory1 or
	not prefs.ctmemory2 or 
	not prefs.csmemory2 then
		prefs.c2x2=0;
		prefs.cgolf=0;
		prefs.cmonte=0;
		prefs.cpairs=0;
		prefs.cwgolf=0;
		prefs.cwmonte=0;
		prefs.cw2x2=0;
		prefs.cwpairs=0;
		prefs.cbayan=0;
		prefs.cwbayan=0;
		prefs.coldfriend=0;
		prefs.cwoldfriend=0;
		prefs.cmemory=0;
		prefs.cwmemory=0;
		prefs.csmemory1=0;
		prefs.csmemory2=0;
		prefs.ctmemory1=0;
		prefs.ctmemory2=0;
	end;

	if not prefs.execute then
		prefs.execute=1;
	else
		prefs.execute=prefs.execute+1;
		prefs:store();
	end;
	
	lifeon('bgm_ctrl');
	playgolf.shuffled=shuffle(playgolf.shuffled);
	playgolf.playable=getplayable(playgolf.shuffled);
	playmonte.shuffled=shuffle(playmonte.shuffled);
	playpairs.shuffled=shuffle_36(playpairs.shuffled);
	playpairs.stack=getpairs(playpairs.shuffled);
	play2x2.shuffled=shuffle(play2x2.shuffled);
	playbayan.shuffled=shuffle(playbayan.shuffled);	

	local i,j;
	for i=1,4 do
		table.insert(play2x2.stack[i], table.remove(play2x2.shuffled));
	end;

	playoldfriend.shuffled=shuffle(playoldfriend.shuffled);

	playoldfriend.stack[1]={};
	for i=2,5 do
		for j=1,5 do
			table.insert(playoldfriend.stack[i], table.remove(playoldfriend.shuffled));
		end;
	end;

	playpam.shuffled=shuffle(playpam.shuffled);

	set_bground();
end;


main = room {
	fading = function()
		return true, 2;
	end;
	nam = [[Главное окно]],
	disp = img('theme/insol.png'),
	dsc = function()
		local t;
		t=[[^{choose|Играть!}^^{options|Настройки}^^{stat|Статистика}^^{hlp|Помощь}^^{abt|О программе}]];
		return txtc(t);
		end;
	obj = {
		xact('choose', code[[set_sound('sounds/click.wav');walk(chgame)]]);
		xact('options', code[[set_sound('sounds/click.wav');walk(scroptions)]]);
		xact('abt', code[[set_sound('sounds/click.wav');walk(about)]]);
		xact('hlp', code[[set_sound('sounds/click.wav');walk(help)]]);
		xact('stat', code[[set_sound('sounds/click.wav');walk(stat)]])
	};
	
};

