-- func.lua
-- файл с функциями. 

-- getpairs -- ?
getpairs = function(tbl)
	local i, j, tmp;
	tmp={{},{},{},{},{},{},{},{},{}};
	for i=1,9 do
		for j=1,4 do
			table.insert(tmp[i], table.remove(tbl));
		end;			
	end;
	return tmp;
end;

-- getplayable -- ?
getplayable = function(tbl)
	local i, tmp;
	tmp={};
	for i=1,35 do
		table.insert(tmp, table.remove(tbl));
	end;
	return tmp;
end;

-- shuffle -- перетасовка колоды в 52 карты
-- TODO: совместить две функции в одну
shuffle = function(shuffletable)
	local source={{1,'c'},{1,'s'},{1,'h'},{1,'d'},
			{2,'c'},{2,'s'},{2,'h'},{2,'d'},
			{3,'c'},{3,'s'},{3,'h'},{3,'d'},
			{4,'c'},{4,'s'},{4,'h'},{4,'d'},
			{5,'c'},{5,'s'},{5,'h'},{5,'d'},
			{6,'c'},{6,'s'},{6,'h'},{6,'d'},
			{7,'c'},{7,'s'},{7,'h'},{7,'d'},
			{8,'c'},{8,'s'},{8,'h'},{8,'d'},
			{9,'c'},{9,'s'},{9,'h'},{9,'d'},
			{10,'c'},{10,'s'},{10,'h'},{10,'d'},
			{11,'c'},{11,'s'},{11,'h'},{11,'d'},
			{12,'c'},{12,'s'},{12,'h'},{12,'d'},
			{13,'c'},{13,'s'},{13,'h'},{13,'d'}};
	local i,tmp;
	shuffletable={};
	while (#source>0) do
		tmp=rnd(#source);
		table.insert(shuffletable, table.remove(source, tmp));
	end;
	return shuffletable;
end;

-- shuffle_36 -- перетасовка колоды в 36 карт
shuffle_36 = function(shuffletable)
	local source={{1,'c'},{1,'s'},{1,'h'},{1,'d'},
			{6,'c'},{6,'s'},{6,'h'},{6,'d'},
			{7,'c'},{7,'s'},{7,'h'},{7,'d'},
			{8,'c'},{8,'s'},{8,'h'},{8,'d'},
			{9,'c'},{9,'s'},{9,'h'},{9,'d'},
			{10,'c'},{10,'s'},{10,'h'},{10,'d'},
			{11,'c'},{11,'s'},{11,'h'},{11,'d'},
			{12,'c'},{12,'s'},{12,'h'},{12,'d'},
			{13,'c'},{13,'s'},{13,'h'},{13,'d'}};
	local i,tmp;
	shuffletable={};
	while (#source>0) do
		tmp=rnd(#source);
		table.insert(shuffletable, table.remove(source, tmp));
	end;
	return shuffletable;
end;

-- ret_bground
-- returns background address
ret_bground = function(bg)
	return "backs/"..bgrounds[bg]..".jpg";
end;

-- ret_thumb
-- retrieve all thumbs
ret_thumb = function(bg)
		return "backs/thumbs/"..bgrounds[bg]..".png";
end;

-- set_bground
-- setting background image
set_bground = function()
	theme.gfx.bg(ret_bground(prefs.bground));
end;
